package org.jeecg.modules.fbsWorkshopDispatchList.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import org.jeecg.modules.fbsWorkshopDispatchList.entity.FbsWorkshopDispatchList;
import org.jeecg.modules.fbsWorkshopDispatchList.mapper.FbsWorkshopDispatchListMapper;
import org.jeecg.modules.fbsWorkshopDispatchList.service.IFbsWorkshopDispatchListService;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @Description: 车间派工单
 * @author： jeecg-boot
 * @date：   2020-10-13
 * @version： V1.0
 */
@Service
@Transactional
public class FbsWorkshopDispatchListServiceImpl extends ServiceImpl<FbsWorkshopDispatchListMapper, FbsWorkshopDispatchList> implements IFbsWorkshopDispatchListService {

    @Resource
    private IFbsWorkshopDispatchListService iFbsWorkshopDispatchListService;

    @Resource
    private FbsWorkshopDispatchListMapper fbsWorkshopDispatchListMapper;
    /**
     * 更新状态
     * @param state 状态（0初始，1接单,2暂停，3完成）
     * @param id
     * @return
     */
    public int updateState(String state,String id){
        return fbsWorkshopDispatchListMapper.updateState(state,id);
    }

    @Override
    public List<FbsWorkshopDispatchList> getSumDispatch() {
        //求和的派工单集合
        List<FbsWorkshopDispatchList> fbsWorkshopDispatchListListSum=fbsWorkshopDispatchListMapper.getSumDispatch();
        //全部派工单为求和
        LambdaQueryWrapper<FbsWorkshopDispatchList> lambdaQueryWrapper=new LambdaQueryWrapper<>();
        lambdaQueryWrapper.eq(FbsWorkshopDispatchList::getDelFlag,"0");
        List<FbsWorkshopDispatchList> fbsWorkshopDispatchListList=iFbsWorkshopDispatchListService.list(lambdaQueryWrapper);
        //两个时间之间的所有日期
        List<Date> dateList=startDateAndEndDate("2020-10-14","2020-10-17");
        SimpleDateFormat fmt = new SimpleDateFormat("yyyy-MM-dd");
        //组装派工单报表数据
        if(fbsWorkshopDispatchListListSum!=null&&fbsWorkshopDispatchListList!=null&&dateList!=null){
            for(FbsWorkshopDispatchList dispatchListSum:fbsWorkshopDispatchListListSum){
                List<FbsWorkshopDispatchList> dispatchListAdd=new ArrayList<>();//需要保存子集集合的派工单（日期分组派工单）
                for(Date date:dateList){
                    String dateString=fmt.format(date);//时间
                    boolean isorder=false;
                    for(FbsWorkshopDispatchList dispatchList:fbsWorkshopDispatchListList){
                        Integer orderIdSum=dispatchListSum.getProductionOrderNumberId();//求和的派工生产单号
                        Integer orderId=dispatchList.getProductionOrderNumberId();//全部派工生产单号
                        String dispatchDate=fmt.format(dispatchList.getDate());//派工时间
                        //找到对应当天的派工单则添加
                        if(orderIdSum.equals(orderId)&&dateString.equals(dispatchDate)){
                            dispatchListAdd.add(dispatchList);
                            isorder=true;
                        }
                    }
                    //没有则添加空的派工单
                    if(isorder==false){
                        FbsWorkshopDispatchList fbsWorkshopDispatchList=new FbsWorkshopDispatchList();
                        fbsWorkshopDispatchList.setDate(date);
                        dispatchListAdd.add(fbsWorkshopDispatchList);
                    }
                }
                dispatchListSum.setFbsWorkshopDispatchListList(dispatchListAdd);
            }
        }

        //获取生产名称合并行
        mergeLines(fbsWorkshopDispatchListListSum);
        return fbsWorkshopDispatchListListSum;
    }

    public List<Date> startDateAndEndDate(String startDate, String endDate) {
        List<Date> list = new ArrayList<>();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        String date1 = startDate; //开始时间
        String date2 = endDate; //结束时间
        Long startTIme = null;
        try {
            startTIme = sdf.parse(date1).getTime();
        } catch (ParseException e) {
            e.printStackTrace();
        }
        Long endTime = null;
        try {
            endTime = sdf.parse(date2).getTime();
        } catch (ParseException e) {
            e.printStackTrace();
        }
        Long oneDay = 1000 * 60 * 60 * 24l;
        Long time = startTIme;
        while (time <= endTime) {
            Date d = new Date(time);
            // DateFormat df = new SimpleDateFormat("yyyy-MM-dd");
            // String date=df.format(d);
            list.add(d);
            time += oneDay;
        }
        return list;
    }

    /**
    * @Author chenchuang
    * @Description //TODO 获取生产名称合并行
    * @Date 2020/10/17 17:23
    * @Param [fbsWorkshopDispatchListList]
    * @return void
    */
    public void mergeLines(List<FbsWorkshopDispatchList> fbsWorkshopDispatchListList){
        if(fbsWorkshopDispatchListList!=null){
            String productionLineId="";
            Integer sort=1;
            for(FbsWorkshopDispatchList fbsWorkshopDispatchList:fbsWorkshopDispatchListList){
                Integer mergeLines=0;
                if(productionLineId.equals("")||!productionLineId.equals(fbsWorkshopDispatchList.getProductionLineId())){
                    productionLineId=fbsWorkshopDispatchList.getProductionLineId();
                    for(FbsWorkshopDispatchList workshopDispatchList:fbsWorkshopDispatchListList){
                        if(productionLineId.equals(workshopDispatchList.getProductionLineId())){
                            mergeLines++;
                        }
                    }
                    fbsWorkshopDispatchList.setSort(sort);
                    sort++;
                }
                fbsWorkshopDispatchList.setMergeLines(mergeLines);
            }
        }
    }
}
